<script setup lang="ts">
  import { CmsBlock, CmsSection } from '@shopware-pwa/types';
  import { getCmsLayoutConfiguration } from '@shopware-pwa/helpers-next';
  import { resolveCmsComponent } from '@shopware-pwa/composables-next';

  const props = defineProps<{
    content: CmsBlock;
  }>();

  const DEFAULT_BG_IMAGE_SIZE = 800;
  const roundUp = (num: number) => {
    return num ? Math.ceil(num / 100) * 100 : DEFAULT_BG_IMAGE_SIZE;
  };

  const getBackgroundImageUrl = (url: string, element: CmsBlock | CmsSection): string => {
    const backgroundImage = encodeURI(url);
    const width = element.backgroundMedia?.metaData.width ?? 0;
    const height = element.backgroundMedia?.metaData.height ?? 0;
    const biggestParam =
      width > height
        ? `width=${roundUp(width > 1920 ? 1900 : width)}`
        : `height=${roundUp(height > 1920 ? 1900 : height)}`;
    const srcPath = `${backgroundImage}?${biggestParam}&fit=crop,smart`;

    return 'url("' + srcPath + '")';
  };

  const DynamicRender = () => {
    const { resolvedComponent, componentName, isResolved } = resolveCmsComponent(props.content);

    if (resolvedComponent) {
      if (!isResolved) return h('div', {}, 'Problem resolving component: ' + componentName);

      const { cssClasses, layoutStyles } = getCmsLayoutConfiguration(props.content);
      if (layoutStyles.backgroundImage) {
        layoutStyles.backgroundImage = getBackgroundImageUrl(
          props.content.backgroundMedia?.url ?? '',
          props.content,
        );
      }

      const containerStyles = {
        backgroundColor: layoutStyles.backgroundColor,
        backgroundImage: layoutStyles.backgroundImage,
      };

      layoutStyles.backgroundColor = null;
      layoutStyles.backgroundImage = null;

      return h(
        'div',
        {
          style: containerStyles,
          name: `cms-block-${componentName}`,
        },
        h(
          'div',
          {
            name: `cms-block-${componentName}-container`,
            style: layoutStyles,
            class: cssClasses,
          },
          h(resolvedComponent, {
            content: props.content,
          }),
        ),
      );
    }
    return h('div', {}, 'Loading...');
  };
</script>

<template>
  <DynamicRender />
</template>
